import he, { useContext as _t, Children as Rt, useMemo as Q, useRef as te, useLayoutEffect as xt, forwardRef as Ct, useEffect as wt, useCallback as bt } from "react";
const Y = {
  UP: "ArrowUp",
  DOWN: "ArrowDown",
  LEFT: "ArrowLeft",
  RIGHT: "ArrowRight",
  END: "End",
  HOME: "Home",
  PAGE_DOWN: "PageDown",
  PAGE_UP: "PageUp",
  ENTER: "Enter",
  TAB: "Tab",
  SPACE: " ",
  BACKSPACE: "Backspace",
  DELETE: "Delete",
  COMMA: ",",
  ESC: "Escape"
};
var M = /* @__PURE__ */ ((i) => (i.Id = "__id__", i.Value = "__value__", i))(M || {});
const Ye = "marked-input";
class mt {
  constructor(t, r) {
    this.raw = t, this.uniRegExp = r, this.done = !1;
  }
  [Symbol.iterator]() {
    return this;
  }
  next() {
    if (this.done)
      return { done: this.done, value: null };
    let t = this.uniRegExp.exec(this.raw);
    if (t === null)
      return this.done = !0, { done: !1, value: [this.raw, null] };
    let [r, n, o] = this.extractSlices(t);
    return this.raw = o, { done: !1, value: [r, n] };
  }
  extractSlices(t) {
    const r = this.extractMark(t), n = r.input.substring(0, r.index), o = r.input.substring(r.index + r.annotation.length);
    return [n, r, o];
  }
  extractMark(t) {
    let r = t[0], n = 0, o = t[1], s = t[2];
    for (; !(o || s); )
      n++, o = t[2 * n + 1], s = t[2 * n + 2];
    let E = t.index, l = t.input;
    return { annotation: r, value: o, id: s, input: l, index: E, childIndex: n };
  }
}
class re {
  get regExps() {
    return this.markups.map(yt);
  }
  static split(t, r) {
    const n = r.map((o) => o.markup);
    return () => new re(n).split(t);
  }
  constructor(t) {
    this.markups = t, this.uniRegExp = new RegExp(this.regExps.map((r) => r.source).join("|"));
  }
  split(t) {
    return this.iterateMatches(t);
  }
  iterateMatches(t) {
    const r = [];
    for (let [n, o] of new mt(t, this.uniRegExp))
      r.push(n), o !== null && r.push(Ot(o, this.markups[o.childIndex]));
    return r;
  }
}
const yt = (i) => {
  const t = de(i), r = i[i.indexOf(M.Value) + M.Value.length], n = i[i.indexOf(M.Id) + M.Id.length];
  return new RegExp(
    t.replace(M.Value, `([^${de(r || "")}]+?)`).replace(M.Id, `([^${de(n || "")}]+?)`)
  );
};
function Ke(i, t, r) {
  let n = i.replace(M.Value, t);
  return r ? n.replace(M.Id, r) : n;
}
function Ft(i, t, ...r) {
  return new re(r).split(i).reduce((o, s) => o += ne(s) ? t(s) : s, "");
}
const de = (i) => i.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
function Le(i, t) {
  let r = "";
  for (let n of i)
    r += ne(n) ? Ke(t[n.childIndex].markup, n.value, n.id) : n;
  return r;
}
const Ot = (i, t) => i.annotation !== Ke(t, i.value, i.id) ? { ...i, id: i.value, value: i.id } : i, ee = (i, t = 0) => {
  let r = 3735928559 ^ t, n = 1103547991 ^ t;
  for (let o = 0, s; o < i.length; o++)
    s = i.charCodeAt(o), r = Math.imul(r ^ s, 2654435761), n = Math.imul(n ^ s, 1597334677);
  return r = Math.imul(r ^ r >>> 16, 2246822507) ^ Math.imul(n ^ n >>> 13, 3266489909), n = Math.imul(n ^ n >>> 16, 2246822507) ^ Math.imul(r ^ r >>> 13, 3266489909), 4294967296 * (2097151 & n) + (r >>> 0);
}, ne = (i) => typeof i == "object";
function Pt(i) {
  return Rt.map(i, (t) => t.props);
}
const Tt = (i) => {
  const t = he.createContext(void 0);
  t.displayName = i;
  const r = o(t), n = s(t);
  return [r, n];
  function o(E) {
    return () => {
      const l = _t(E);
      if (l)
        return l;
      throw new Error(`The context ${E.displayName} didn't found!`);
    };
  }
  function s(E) {
    return E.Provider;
  }
}, [ge, St] = Tt("MarkedInputStoreProvider"), jt = () => Q(() => new U(), []);
class U {
  constructor(t = NaN) {
    this._position = t;
  }
  get isBlurred() {
    return Number.isNaN(this._position);
  }
  clear() {
    this._position = NaN;
  }
  static setIndex(t, r) {
    const n = window.getSelection();
    if (!(n != null && n.anchorNode) || !n.rangeCount)
      return;
    const o = n.getRangeAt(0);
    o == null || o.setStart(t.firstChild || t, r), o == null || o.setEnd(t.firstChild || t, r);
  }
  static getCaretIndex(t) {
    let r = 0;
    const n = window.getSelection();
    if (!(n != null && n.rangeCount))
      return r;
    const o = n.getRangeAt(0), s = o.cloneRange();
    return s.selectNodeContents(t), s.setEnd(o.endContainer, o.endOffset), r = s.toString().length, r;
  }
  getPosition() {
    let t = this._position;
    return this._position = NaN, t;
  }
  setPosition(t) {
    this._position = t;
  }
  static setCaretToEnd(t) {
    const r = window.getSelection();
    r == null || r.setPosition(t, 1);
  }
  static getIndex() {
    var r;
    const t = window.getSelection();
    return (r = t == null ? void 0 : t.anchorOffset) != null ? r : NaN;
  }
  saveRightOffset() {
    var n, o;
    const t = window.getSelection(), r = (o = (n = t == null ? void 0 : t.anchorNode) == null ? void 0 : n.textContent) == null ? void 0 : o.length;
    this._position = r != null ? r : NaN;
  }
  restoreRightOffset() {
    var s, E;
    if (this.isBlurred)
      return;
    const t = window.getSelection(), r = t != null && t.rangeCount ? t.getRangeAt(0) : null;
    if (!(t != null && t.anchorNode))
      return;
    let n = (t == null ? void 0 : t.anchorNode.firstChild) || (t == null ? void 0 : t.anchorNode), o = ((E = (s = n == null ? void 0 : n.textContent) == null ? void 0 : s.length) != null ? E : 0) - this._position;
    r == null || r.setStart(n, o), r == null || r.setEnd(n, o), this.clear();
  }
  static setIndex1(t) {
    const r = window.getSelection();
    if (!(r != null && r.anchorNode) || !r.rangeCount)
      return;
    const n = r.getRangeAt(0);
    n == null || n.setStart(n.startContainer.firstChild || n.startContainer, t), n == null || n.setEnd(n.startContainer.firstChild || n.startContainer, t);
  }
  setCaretRightTo(t, r) {
    const n = window.getSelection(), o = n == null ? void 0 : n.getRangeAt(0);
    o == null || o.setStart(o.endContainer, r), o == null || o.setEnd(o.endContainer, r);
  }
}
const kt = (i) => {
  const t = te(NaN);
  function r() {
    !i.current || (t.current = U.getCaretIndex(i.current));
  }
  function n() {
    !i.current || (U.setIndex(i.current, t.current), t.current = NaN);
  }
  return xt(() => {
    Number.isNaN(t.current) || n();
  }), r;
};
var F = /* @__PURE__ */ ((i) => (i[i.Change = 0] = "Change", i[i.Delete = 1] = "Delete", i))(F || {}), Be = { exports: {} }, L = {};
/*
object-assign
(c) Sindre Sorhus
@license MIT
*/
var pe, Ve;
function qe() {
  if (Ve)
    return pe;
  Ve = 1;
  var i = Object.getOwnPropertySymbols, t = Object.prototype.hasOwnProperty, r = Object.prototype.propertyIsEnumerable;
  function n(s) {
    if (s == null)
      throw new TypeError("Object.assign cannot be called with null or undefined");
    return Object(s);
  }
  function o() {
    try {
      if (!Object.assign)
        return !1;
      var s = new String("abc");
      if (s[5] = "de", Object.getOwnPropertyNames(s)[0] === "5")
        return !1;
      for (var E = {}, l = 0; l < 10; l++)
        E["_" + String.fromCharCode(l)] = l;
      var h = Object.getOwnPropertyNames(E).map(function(f) {
        return E[f];
      });
      if (h.join("") !== "0123456789")
        return !1;
      var _ = {};
      return "abcdefghijklmnopqrst".split("").forEach(function(f) {
        _[f] = f;
      }), Object.keys(Object.assign({}, _)).join("") === "abcdefghijklmnopqrst";
    } catch {
      return !1;
    }
  }
  return pe = o() ? Object.assign : function(s, E) {
    for (var l, h = n(s), _, f = 1; f < arguments.length; f++) {
      l = Object(arguments[f]);
      for (var d in l)
        t.call(l, d) && (h[d] = l[d]);
      if (i) {
        _ = i(l);
        for (var p = 0; p < _.length; p++)
          r.call(l, _[p]) && (h[_[p]] = l[_[p]]);
      }
    }
    return h;
  }, pe;
}
/** @license React v17.0.2
 * react-jsx-runtime.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var Ue;
function Dt() {
  if (Ue)
    return L;
  Ue = 1, qe();
  var i = he, t = 60103;
  if (L.Fragment = 60107, typeof Symbol == "function" && Symbol.for) {
    var r = Symbol.for;
    t = r("react.element"), L.Fragment = r("react.fragment");
  }
  var n = i.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, o = Object.prototype.hasOwnProperty, s = { key: !0, ref: !0, __self: !0, __source: !0 };
  function E(l, h, _) {
    var f, d = {}, p = null, w = null;
    _ !== void 0 && (p = "" + _), h.key !== void 0 && (p = "" + h.key), h.ref !== void 0 && (w = h.ref);
    for (f in h)
      o.call(h, f) && !s.hasOwnProperty(f) && (d[f] = h[f]);
    if (l && l.defaultProps)
      for (f in h = l.defaultProps, h)
        d[f] === void 0 && (d[f] = h[f]);
    return { $$typeof: t, type: l, key: p, ref: w, props: d, _owner: n.current };
  }
  return L.jsx = E, L.jsxs = E, L;
}
var ve = {};
/** @license React v17.0.2
 * react-jsx-runtime.development.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var Fe;
function It() {
  return Fe || (Fe = 1, function(i) {
    process.env.NODE_ENV !== "production" && function() {
      var t = he, r = qe(), n = 60103, o = 60106;
      i.Fragment = 60107;
      var s = 60108, E = 60114, l = 60109, h = 60110, _ = 60112, f = 60113, d = 60120, p = 60115, w = 60116, T = 60121, I = 60122, S = 60117, j = 60129, k = 60131;
      if (typeof Symbol == "function" && Symbol.for) {
        var R = Symbol.for;
        n = R("react.element"), o = R("react.portal"), i.Fragment = R("react.fragment"), s = R("react.strict_mode"), E = R("react.profiler"), l = R("react.provider"), h = R("react.context"), _ = R("react.forward_ref"), f = R("react.suspense"), d = R("react.suspense_list"), p = R("react.memo"), w = R("react.lazy"), T = R("react.block"), I = R("react.server.block"), S = R("react.fundamental"), R("react.scope"), R("react.opaque.id"), j = R("react.debug_trace_mode"), R("react.offscreen"), k = R("react.legacy_hidden");
      }
      var q = typeof Symbol == "function" && Symbol.iterator, G = "@@iterator";
      function H(e) {
        if (e === null || typeof e != "object")
          return null;
        var a = q && e[q] || e[G];
        return typeof a == "function" ? a : null;
      }
      var y = t.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED;
      function O(e) {
        {
          for (var a = arguments.length, u = new Array(a > 1 ? a - 1 : 0), c = 1; c < a; c++)
            u[c - 1] = arguments[c];
          Ge("error", e, u);
        }
      }
      function Ge(e, a, u) {
        {
          var c = y.ReactDebugCurrentFrame, x = c.getStackAddendum();
          x !== "" && (a += "%s", u = u.concat([x]));
          var C = u.map(function(g) {
            return "" + g;
          });
          C.unshift("Warning: " + a), Function.prototype.apply.call(console[e], console, C);
        }
      }
      var He = !1;
      function Je(e) {
        return !!(typeof e == "string" || typeof e == "function" || e === i.Fragment || e === E || e === j || e === s || e === f || e === d || e === k || He || typeof e == "object" && e !== null && (e.$$typeof === w || e.$$typeof === p || e.$$typeof === l || e.$$typeof === h || e.$$typeof === _ || e.$$typeof === S || e.$$typeof === T || e[0] === I));
      }
      function ze(e, a, u) {
        var c = a.displayName || a.name || "";
        return e.displayName || (c !== "" ? u + "(" + c + ")" : u);
      }
      function Ee(e) {
        return e.displayName || "Context";
      }
      function D(e) {
        if (e == null)
          return null;
        if (typeof e.tag == "number" && O("Received an unexpected object in getComponentName(). This is likely a bug in React. Please file an issue."), typeof e == "function")
          return e.displayName || e.name || null;
        if (typeof e == "string")
          return e;
        switch (e) {
          case i.Fragment:
            return "Fragment";
          case o:
            return "Portal";
          case E:
            return "Profiler";
          case s:
            return "StrictMode";
          case f:
            return "Suspense";
          case d:
            return "SuspenseList";
        }
        if (typeof e == "object")
          switch (e.$$typeof) {
            case h:
              var a = e;
              return Ee(a) + ".Consumer";
            case l:
              var u = e;
              return Ee(u._context) + ".Provider";
            case _:
              return ze(e, e.render, "ForwardRef");
            case p:
              return D(e.type);
            case T:
              return D(e._render);
            case w: {
              var c = e, x = c._payload, C = c._init;
              try {
                return D(C(x));
              } catch {
                return null;
              }
            }
          }
        return null;
      }
      var K = 0, _e, Re, xe, Ce, we, be, me;
      function ye() {
      }
      ye.__reactDisabledLog = !0;
      function Xe() {
        {
          if (K === 0) {
            _e = console.log, Re = console.info, xe = console.warn, Ce = console.error, we = console.group, be = console.groupCollapsed, me = console.groupEnd;
            var e = {
              configurable: !0,
              enumerable: !0,
              value: ye,
              writable: !0
            };
            Object.defineProperties(console, {
              info: e,
              log: e,
              warn: e,
              error: e,
              group: e,
              groupCollapsed: e,
              groupEnd: e
            });
          }
          K++;
        }
      }
      function Ze() {
        {
          if (K--, K === 0) {
            var e = {
              configurable: !0,
              enumerable: !0,
              writable: !0
            };
            Object.defineProperties(console, {
              log: r({}, e, {
                value: _e
              }),
              info: r({}, e, {
                value: Re
              }),
              warn: r({}, e, {
                value: xe
              }),
              error: r({}, e, {
                value: Ce
              }),
              group: r({}, e, {
                value: we
              }),
              groupCollapsed: r({}, e, {
                value: be
              }),
              groupEnd: r({}, e, {
                value: me
              })
            });
          }
          K < 0 && O("disabledDepth fell below zero. This is a bug in React. Please file an issue.");
        }
      }
      var ae = y.ReactCurrentDispatcher, ie;
      function J(e, a, u) {
        {
          if (ie === void 0)
            try {
              throw Error();
            } catch (x) {
              var c = x.stack.trim().match(/\n( *(at )?)/);
              ie = c && c[1] || "";
            }
          return `
` + ie + e;
        }
      }
      var oe = !1, z;
      {
        var Qe = typeof WeakMap == "function" ? WeakMap : Map;
        z = new Qe();
      }
      function Oe(e, a) {
        if (!e || oe)
          return "";
        {
          var u = z.get(e);
          if (u !== void 0)
            return u;
        }
        var c;
        oe = !0;
        var x = Error.prepareStackTrace;
        Error.prepareStackTrace = void 0;
        var C;
        C = ae.current, ae.current = null, Xe();
        try {
          if (a) {
            var g = function() {
              throw Error();
            };
            if (Object.defineProperty(g.prototype, "props", {
              set: function() {
                throw Error();
              }
            }), typeof Reflect == "object" && Reflect.construct) {
              try {
                Reflect.construct(g, []);
              } catch (N) {
                c = N;
              }
              Reflect.construct(e, [], g);
            } else {
              try {
                g.call();
              } catch (N) {
                c = N;
              }
              e.call(g.prototype);
            }
          } else {
            try {
              throw Error();
            } catch (N) {
              c = N;
            }
            e();
          }
        } catch (N) {
          if (N && c && typeof N.stack == "string") {
            for (var v = N.stack.split(`
`), P = c.stack.split(`
`), b = v.length - 1, m = P.length - 1; b >= 1 && m >= 0 && v[b] !== P[m]; )
              m--;
            for (; b >= 1 && m >= 0; b--, m--)
              if (v[b] !== P[m]) {
                if (b !== 1 || m !== 1)
                  do
                    if (b--, m--, m < 0 || v[b] !== P[m]) {
                      var A = `
` + v[b].replace(" at new ", " at ");
                      return typeof e == "function" && z.set(e, A), A;
                    }
                  while (b >= 1 && m >= 0);
                break;
              }
          }
        } finally {
          oe = !1, ae.current = C, Ze(), Error.prepareStackTrace = x;
        }
        var W = e ? e.displayName || e.name : "", We = W ? J(W) : "";
        return typeof e == "function" && z.set(e, We), We;
      }
      function Pe(e, a, u) {
        return Oe(e, !1);
      }
      function et(e) {
        var a = e.prototype;
        return !!(a && a.isReactComponent);
      }
      function X(e, a, u) {
        if (e == null)
          return "";
        if (typeof e == "function")
          return Oe(e, et(e));
        if (typeof e == "string")
          return J(e);
        switch (e) {
          case f:
            return J("Suspense");
          case d:
            return J("SuspenseList");
        }
        if (typeof e == "object")
          switch (e.$$typeof) {
            case _:
              return Pe(e.render);
            case p:
              return X(e.type, a, u);
            case T:
              return Pe(e._render);
            case w: {
              var c = e, x = c._payload, C = c._init;
              try {
                return X(C(x), a, u);
              } catch {
              }
            }
          }
        return "";
      }
      var Te = {}, Se = y.ReactDebugCurrentFrame;
      function Z(e) {
        if (e) {
          var a = e._owner, u = X(e.type, e._source, a ? a.type : null);
          Se.setExtraStackFrame(u);
        } else
          Se.setExtraStackFrame(null);
      }
      function tt(e, a, u, c, x) {
        {
          var C = Function.call.bind(Object.prototype.hasOwnProperty);
          for (var g in e)
            if (C(e, g)) {
              var v = void 0;
              try {
                if (typeof e[g] != "function") {
                  var P = Error((c || "React class") + ": " + u + " type `" + g + "` is invalid; it must be a function, usually from the `prop-types` package, but received `" + typeof e[g] + "`.This often happens because of typos such as `PropTypes.function` instead of `PropTypes.func`.");
                  throw P.name = "Invariant Violation", P;
                }
                v = e[g](a, g, c, u, null, "SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED");
              } catch (b) {
                v = b;
              }
              v && !(v instanceof Error) && (Z(x), O("%s: type specification of %s `%s` is invalid; the type checker function must return `null` or an `Error` but returned a %s. You may have forgotten to pass an argument to the type checker creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and shape all require an argument).", c || "React class", u, g, typeof v), Z(null)), v instanceof Error && !(v.message in Te) && (Te[v.message] = !0, Z(x), O("Failed %s type: %s", u, v.message), Z(null));
            }
        }
      }
      var B = y.ReactCurrentOwner, ue = Object.prototype.hasOwnProperty, rt = {
        key: !0,
        ref: !0,
        __self: !0,
        __source: !0
      }, je, ke, se;
      se = {};
      function nt(e) {
        if (ue.call(e, "ref")) {
          var a = Object.getOwnPropertyDescriptor(e, "ref").get;
          if (a && a.isReactWarning)
            return !1;
        }
        return e.ref !== void 0;
      }
      function at(e) {
        if (ue.call(e, "key")) {
          var a = Object.getOwnPropertyDescriptor(e, "key").get;
          if (a && a.isReactWarning)
            return !1;
        }
        return e.key !== void 0;
      }
      function it(e, a) {
        if (typeof e.ref == "string" && B.current && a && B.current.stateNode !== a) {
          var u = D(B.current.type);
          se[u] || (O('Component "%s" contains the string ref "%s". Support for string refs will be removed in a future major release. This case cannot be automatically converted to an arrow function. We ask you to manually fix this case by using useRef() or createRef() instead. Learn more about using refs safely here: https://reactjs.org/link/strict-mode-string-ref', D(B.current.type), e.ref), se[u] = !0);
        }
      }
      function ot(e, a) {
        {
          var u = function() {
            je || (je = !0, O("%s: `key` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", a));
          };
          u.isReactWarning = !0, Object.defineProperty(e, "key", {
            get: u,
            configurable: !0
          });
        }
      }
      function ut(e, a) {
        {
          var u = function() {
            ke || (ke = !0, O("%s: `ref` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", a));
          };
          u.isReactWarning = !0, Object.defineProperty(e, "ref", {
            get: u,
            configurable: !0
          });
        }
      }
      var st = function(e, a, u, c, x, C, g) {
        var v = {
          $$typeof: n,
          type: e,
          key: a,
          ref: u,
          props: g,
          _owner: C
        };
        return v._store = {}, Object.defineProperty(v._store, "validated", {
          configurable: !1,
          enumerable: !1,
          writable: !0,
          value: !1
        }), Object.defineProperty(v, "_self", {
          configurable: !1,
          enumerable: !1,
          writable: !1,
          value: c
        }), Object.defineProperty(v, "_source", {
          configurable: !1,
          enumerable: !1,
          writable: !1,
          value: x
        }), Object.freeze && (Object.freeze(v.props), Object.freeze(v)), v;
      };
      function ct(e, a, u, c, x) {
        {
          var C, g = {}, v = null, P = null;
          u !== void 0 && (v = "" + u), at(a) && (v = "" + a.key), nt(a) && (P = a.ref, it(a, x));
          for (C in a)
            ue.call(a, C) && !rt.hasOwnProperty(C) && (g[C] = a[C]);
          if (e && e.defaultProps) {
            var b = e.defaultProps;
            for (C in b)
              g[C] === void 0 && (g[C] = b[C]);
          }
          if (v || P) {
            var m = typeof e == "function" ? e.displayName || e.name || "Unknown" : e;
            v && ot(g, m), P && ut(g, m);
          }
          return st(e, v, P, x, c, B.current, g);
        }
      }
      var ce = y.ReactCurrentOwner, De = y.ReactDebugCurrentFrame;
      function $(e) {
        if (e) {
          var a = e._owner, u = X(e.type, e._source, a ? a.type : null);
          De.setExtraStackFrame(u);
        } else
          De.setExtraStackFrame(null);
      }
      var le;
      le = !1;
      function fe(e) {
        return typeof e == "object" && e !== null && e.$$typeof === n;
      }
      function Ie() {
        {
          if (ce.current) {
            var e = D(ce.current.type);
            if (e)
              return `

Check the render method of \`` + e + "`.";
          }
          return "";
        }
      }
      function lt(e) {
        {
          if (e !== void 0) {
            var a = e.fileName.replace(/^.*[\\\/]/, ""), u = e.lineNumber;
            return `

Check your code at ` + a + ":" + u + ".";
          }
          return "";
        }
      }
      var Ae = {};
      function ft(e) {
        {
          var a = Ie();
          if (!a) {
            var u = typeof e == "string" ? e : e.displayName || e.name;
            u && (a = `

Check the top-level render call using <` + u + ">.");
          }
          return a;
        }
      }
      function Ne(e, a) {
        {
          if (!e._store || e._store.validated || e.key != null)
            return;
          e._store.validated = !0;
          var u = ft(a);
          if (Ae[u])
            return;
          Ae[u] = !0;
          var c = "";
          e && e._owner && e._owner !== ce.current && (c = " It was passed a child from " + D(e._owner.type) + "."), $(e), O('Each child in a list should have a unique "key" prop.%s%s See https://reactjs.org/link/warning-keys for more information.', u, c), $(null);
        }
      }
      function Me(e, a) {
        {
          if (typeof e != "object")
            return;
          if (Array.isArray(e))
            for (var u = 0; u < e.length; u++) {
              var c = e[u];
              fe(c) && Ne(c, a);
            }
          else if (fe(e))
            e._store && (e._store.validated = !0);
          else if (e) {
            var x = H(e);
            if (typeof x == "function" && x !== e.entries)
              for (var C = x.call(e), g; !(g = C.next()).done; )
                fe(g.value) && Ne(g.value, a);
          }
        }
      }
      function dt(e) {
        {
          var a = e.type;
          if (a == null || typeof a == "string")
            return;
          var u;
          if (typeof a == "function")
            u = a.propTypes;
          else if (typeof a == "object" && (a.$$typeof === _ || a.$$typeof === p))
            u = a.propTypes;
          else
            return;
          if (u) {
            var c = D(a);
            tt(u, e.props, "prop", c, e);
          } else if (a.PropTypes !== void 0 && !le) {
            le = !0;
            var x = D(a);
            O("Component %s declared `PropTypes` instead of `propTypes`. Did you misspell the property assignment?", x || "Unknown");
          }
          typeof a.getDefaultProps == "function" && !a.getDefaultProps.isReactClassApproved && O("getDefaultProps is only used on classic React.createClass definitions. Use a static property named `defaultProps` instead.");
        }
      }
      function pt(e) {
        {
          for (var a = Object.keys(e.props), u = 0; u < a.length; u++) {
            var c = a[u];
            if (c !== "children" && c !== "key") {
              $(e), O("Invalid prop `%s` supplied to `React.Fragment`. React.Fragment can only have `key` and `children` props.", c), $(null);
              break;
            }
          }
          e.ref !== null && ($(e), O("Invalid attribute `ref` supplied to `React.Fragment`."), $(null));
        }
      }
      function $e(e, a, u, c, x, C) {
        {
          var g = Je(e);
          if (!g) {
            var v = "";
            (e === void 0 || typeof e == "object" && e !== null && Object.keys(e).length === 0) && (v += " You likely forgot to export your component from the file it's defined in, or you might have mixed up default and named imports.");
            var P = lt(x);
            P ? v += P : v += Ie();
            var b;
            e === null ? b = "null" : Array.isArray(e) ? b = "array" : e !== void 0 && e.$$typeof === n ? (b = "<" + (D(e.type) || "Unknown") + " />", v = " Did you accidentally export a JSX literal instead of a component?") : b = typeof e, O("React.jsx: type is invalid -- expected a string (for built-in components) or a class/function (for composite components) but got: %s.%s", b, v);
          }
          var m = ct(e, a, u, x, C);
          if (m == null)
            return m;
          if (g) {
            var A = a.children;
            if (A !== void 0)
              if (c)
                if (Array.isArray(A)) {
                  for (var W = 0; W < A.length; W++)
                    Me(A[W], e);
                  Object.freeze && Object.freeze(A);
                } else
                  O("React.jsx: Static children should always be an array. You are likely explicitly calling React.jsxs or React.jsxDEV. Use the Babel transform instead.");
              else
                Me(A, e);
          }
          return e === i.Fragment ? pt(m) : dt(m), m;
        }
      }
      function vt(e, a, u) {
        return $e(e, a, u, !0);
      }
      function ht(e, a, u) {
        return $e(e, a, u, !1);
      }
      var gt = ht, Et = vt;
      i.jsx = gt, i.jsxs = Et;
    }();
  }(ve)), ve;
}
(function(i) {
  process.env.NODE_ENV === "production" ? i.exports = Dt() : i.exports = It();
})(Be);
const V = Be.exports.jsx, At = Ct(({
  id: i,
  value: t
}, r) => {
  const {
    dispatch: n,
    props: {
      readOnly: o,
      spanStyle: s,
      spanClassName: E
    }
  } = ge(), l = te(null);
  typeof r == "function" && r(l);
  const h = kt(l);
  return /* @__PURE__ */ V("span", {
    ref: l,
    style: s,
    className: E,
    contentEditable: !o,
    suppressContentEditableWarning: !0,
    onInput: (f) => {
      var p;
      h();
      const d = (p = f.currentTarget.textContent) != null ? p : "";
      n(F.Change, {
        key: i,
        value: d
      });
    },
    onPaste: Nt,
    children: t
  });
});
function Nt(i) {
  i.preventDefault();
  const t = i.clipboardData.getData("text");
  document.execCommand("insertText", !1, t);
}
const Mt = () => {
  const i = jt(), t = {
    current: /* @__PURE__ */ new Map()
  }, {
    dispatch: r,
    sliceMap: n
  } = ge(), o = [...n.keys()], s = te(null), E = $t(i, t), l = (d) => {
    var G, H;
    const p = d.target, w = U.getCaretIndex(p), T = w === 0, I = w === ((G = p.textContent) == null ? void 0 : G.length), S = {
      [Y.LEFT]: T ? j : null,
      [Y.RIGHT]: I ? k : null,
      [Y.UP]: null,
      [Y.DOWN]: null,
      [Y.DELETE]: I ? q : null,
      [Y.BACKSPACE]: T ? R : null
    };
    (H = S[d.key]) == null || H.call(S);
    function j() {
      if (s.current && s.current !== 0) {
        let y = f()[s.current - 1].current;
        y == null || y.focus(), U.setCaretToEnd(y);
      }
      d.preventDefault();
    }
    function k() {
      var y;
      s.current !== null && s.current !== [...t.current.values()].length - 1 && ((y = f()[s.current + 1].current) == null || y.focus()), d.preventDefault();
    }
    function R() {
      if (s.current && s.current > 0) {
        E.current = h();
        let y = [...t.current.keys()][s.current], O = o.indexOf(y);
        r(F.Delete, {
          key: o[O - 1]
        });
      }
    }
    function q() {
      if (s.current !== null && s.current !== [...t.current.values()].length - 1) {
        E.current = _();
        let y = [...t.current.keys()][s.current], O = o.indexOf(y);
        r(F.Delete, {
          key: o[O + 1]
        });
      }
    }
  };
  function h() {
    var S, j, k, R;
    if (s.current === null)
      return null;
    let d = [...t.current.keys()][s.current - 1], p = [...t.current.keys()][s.current], w = (j = (S = t.current.get(d)) == null ? void 0 : S.current) == null ? void 0 : j.textContent, T = (R = (k = t.current.get(p)) == null ? void 0 : k.current) == null ? void 0 : R.textContent, I = w + T;
    return i.setPosition(w.length), ee(I);
  }
  function _() {
    var S, j, k, R;
    if (s.current === null)
      return null;
    let d = [...t.current.keys()][s.current + 1], p = [...t.current.keys()][s.current], w = (j = (S = t.current.get(d)) == null ? void 0 : S.current) == null ? void 0 : j.textContent, T = (R = (k = t.current.get(p)) == null ? void 0 : k.current) == null ? void 0 : R.textContent, I = T + w;
    return i.setPosition(T.length), ee(I);
  }
  function f() {
    return [...t.current.values()];
  }
  return {
    register: (d) => (p) => t.current.set(d, p),
    onFocus: (d) => {
      s.current = [...t.current.values()].findIndex((p) => p.current === d.target);
    },
    onBlur: () => s.current = null,
    onKeyDown: l
  };
}, $t = (i, t) => {
  const r = te(null);
  return wt(() => {
    var n;
    if (r.current) {
      let o = (n = t.current.get(r.current)) == null ? void 0 : n.current;
      o.focus();
      let s = i.getPosition();
      s && o && U.setIndex(o, s), r.current = null;
    }
  }), r;
}, Wt = () => {
  const {
    sliceMap: i,
    configs: t,
    props: {
      Mark: r,
      ...n
    }
  } = ge(), {
    register: o,
    ...s
  } = Mt(), E = n.className ? Ye + " " + n.className : Ye;
  return /* @__PURE__ */ V("div", {
    className: E,
    style: n.style,
    ...s,
    children: [...i].map(([l, h]) => ne(h) ? /* @__PURE__ */ V(r, {
      tabIndex: -1,
      ...t[h.childIndex].initializer(h.value, h.id)
    }, l) : /* @__PURE__ */ V(At, {
      ref: o(l),
      id: l,
      value: h
    }, l))
  });
};
const Yt = (i) => Q(() => Pt(i), [i]), Lt = ({ value: i, onChange: t }, r) => {
  const n = Q(re.split(i, r), [i]), o = Q(E, [n.length]), s = l();
  return [o, s];
  function E() {
    return n.reduce((_, f) => _.set(h(f, _), f), /* @__PURE__ */ new Map());
    function h(_, f) {
      let d = ne(_) ? _.id + _.value : _, p = 0, w = ee(d, p);
      for (; f.has(w); )
        w = ee(d, p++);
      return w;
    }
  }
  function l() {
    return bt((h, _) => {
      f(o, { type: h, payload: _ });
      function f(d, p) {
        switch (p.type) {
          case F.Change:
            const { key: w, value: T = "" } = p.payload;
            d.set(w, T), t(Le([...d.values()], r));
            break;
          case F.Delete:
            d.delete(p.payload.key), t(Le([...d.values()], r));
            break;
          default:
            throw new Error();
        }
      }
    }, [o]);
  }
}, Vt = (i) => {
  const t = Yt(i.children), [r, n] = Lt(i, t);
  return {
    configs: t,
    props: i,
    sliceMap: r,
    dispatch: n
  };
}, Kt = (i) => {
  const t = Vt(i);
  return /* @__PURE__ */ V(St, {
    value: t,
    children: /* @__PURE__ */ V(Wt, {})
  });
}, Bt = (i) => null;
function styleInject(css,ref){if(ref===void 0){ref={}}var insertAt=ref.insertAt;if(!css||typeof document==="undefined"){return}var head=document.head||document.getElementsByTagName("head")[0];var style=document.createElement("style");style.type="text/css";if(insertAt==="top"){if(head.firstChild){head.insertBefore(style,head.firstChild)}else{head.appendChild(style)}}else{head.appendChild(style)}if(style.styleSheet){style.styleSheet.cssText=css}else{style.appendChild(document.createTextNode(css))}};styleInject(`.marked-input {
}
.marked-input span {
    outline: none;
    white-space: pre-wrap;
}

`);
export {
  Kt as MarkedInput,
  Bt as Option,
  Ke as annotate,
  Ft as denote
};
